﻿Imports SldWorks
Imports SwConst

Public Class Form1



    Dim DatenbankName As String = "Hansa A01"

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Dim swModelDoc As ModelDoc2
        Dim oSwAssembly As SldWorks.AssemblyDoc
        Dim swModelDocExt As ModelDocExtension
        Dim openFile As String
        Dim warnings As Integer
        Dim errors As Integer
        Dim swApp As SldWorks.SldWorks

        swApp = CreateObject("SldWorks.Application")

        If DatenbankName = "Bitte eingeben!" Then
            DatenbankName = InputBox("Bitte Datenbank eingeben:", "Datenbank", "solidworks materials")
        End If

        Dim WarOffen As Boolean = True
        If swApp.Visible = False Then
            swApp.Visible = True
            WarOffen = False
        End If

        Try
            oSwAssembly = swApp.ActiveDoc
        Catch ex As Exception
            oSwAssembly = Nothing

            Part(swApp.ActiveDoc)
            Exit Sub
        End Try

        Form2.Show(Me)
        Form2.Label1.Text = "Bitte warten...SolidWorks nicht benutzen!" & vbCrLf & "Ermittelt enthaltene Komponenten"
        Dim liste As New List(Of SldWorks.Component2)
        liste = GetComponents(oSwAssembly, False)

        Dim ListeFertig As New List(Of String)

        For i As Integer = 0 To liste.Count - 1
            Try
                Form2.Label1.Text = "Bitte warten...SolidWorks nicht benutzen!" & vbCrLf & _
                    "Anzahl Komponenten: " & liste.Count - 1 & vbCrLf & _
                    "Verarbeitet: " & i & vbCrLf & _
                    "Bearbeite: " & liste(i).Name2
                'Application.DoEvents()
                'System.Threading.Thread.Sleep(20)
                Dim Model As SldWorks.ModelDoc2
                Model = liste(i).GetModelDoc2

                Dim Material As String = ""
                Dim Database As String = ""


                Dim Configurations As Object = Model.GetConfigurationNames

                For Each Config As String In Configurations
                    'For iConf As Integer = 0 To Configurations.count - 1
                    Material = Model.GetMaterialPropertyName2(Config, Database)

                    If Not Material = "" Then
                        Model.SetMaterialPropertyName2("", DatenbankName, Material)
                        ListeFertig.Add(liste(i).Name2 & " - " & Config & " - " & Material)
                    End If
                Next


                Material = Model.GetMaterialPropertyName2("", Database)
                Debug.WriteLine(Material)

                If Not Material = "" Then
                    Model.SetMaterialPropertyName2("", DatenbankName, Material)
                    ListeFertig.Add(liste(i).Name2 & " - " & Material)
                End If
            Catch ex As Exception
                'MsgBox(ex.Message)
            End Try
        Next

        NeuaufbauUndListe(ListeFertig, oSwAssembly)
    End Sub

    Private Sub Part(ByVal Model As ModelDoc2)
        Dim Material As String
        Dim Database As String = ""
        Dim ListeFertig As New List(Of String)


        Dim Configurations As Object = Model.GetConfigurationNames

        For Each Config As String In Configurations
            'For iConf As Integer = 0 To Configurations.count - 1
            Material = Model.GetMaterialPropertyName2(Config, Database)

            If Not Material = "" Then
                Model.SetMaterialPropertyName2("", DatenbankName, Material)
                ListeFertig.Add(Config & " - " & Material)
            End If
        Next
        Try
            NeuaufbauUndListe(ListeFertig, Model)
        Catch ex As Exception
        End Try
    End Sub

    Private Sub NeuaufbauUndListe(ByVal ListeFertig As List(Of String), ByVal oSwAssembly As SldWorks.ModelDoc2)
        Form2.Label1.Text = "Bitte warten...SolidWorks nicht benutzen!" & vbCrLf & _
           "Statustext wird generiert..."
        TextBox1.Clear()
        For i As Integer = 0 To ListeFertig.Count - 1
            TextBox1.Text += ListeFertig(i) & vbCrLf
        Next

        Form2.Label1.Text = "Bitte warten...SolidWorks nicht benutzen!" & vbCrLf & _
                    "Modell wird neu aufgebaut..."

        ModelUpdate(oSwAssembly, False)

        Form2.Visible = False
    End Sub
    ''' <summary>
    ''' Die Function "GetComponents" ermittelt alle in der übergebenen Baugruppe (Parameter oSwAssembly) vorhandenen Komponenten. 
    ''' Also alle in dieser Baugruppe verbauten Bauteile und Unterbaugruppen.
    ''' Der Parameter bTopLevelOnly legt fest ob nur die Komponenten der ersten Ebene, also direkte Komponenten der Baugruppe, 
    ''' oder alle Komponenten, auch der Unterbaugruppen, ermittelt werden.
    ''' </summary>
    ''' <param name="oSwAssembly"></param>
    ''' <param name="bTopLevelOnly"></param>
    ''' <returns></returns>
    ''' <remarks>Quelle www.mysldworks.de/</remarks>
    Public Function GetComponents( _
                    ByVal oSwAssembly As SldWorks.AssemblyDoc, _
                    ByVal bTopLevelOnly As Boolean) As  _
                    List(Of SldWorks.Component2)
        Try
            Dim oComponentDummyObjekt As Object
            Dim oComponentDummyArray() As Object
            Dim oSwComponents As List(Of SldWorks.Component2)
            oComponentDummyObjekt = _
                oSwAssembly.GetComponents(bTopLevelOnly)
            oComponentDummyArray = _
                CType(oComponentDummyObjekt, [Object]())
            oSwComponents = New List(Of SldWorks.Component2)
            For iComponente As Integer = 0 To _
                            oComponentDummyArray.GetUpperBound(0)
                oSwComponents.Add( _
                    CType(oComponentDummyArray(iComponente),  _
                    SldWorks.Component2))
            Next
            Return oSwComponents
        Catch ex As Exception
            Debug.Assert(False)
            Trace.WriteLine("Fehler: Wo: " & _
                ex.StackTrace & " Was: " & ex.Message)
            Return Nothing
        End Try
    End Function

    ''' <summary>
    ''' Aktualisiert ein geöffnetes Dokument 
    ''' durch Neuaufbau und Neuzeichnen in SolidWorks
    ''' </summary>
    ''' <param name="oSwModel">SolidWorks Dokument</param>
    ''' <param name="bEditOnly">
    ''' True = Nur bearbeitete Elemente neu aufbauen, 
    ''' welche einen Neuaufbau benötigen
    ''' False = Komplettes Dokument neu aufbauen</param>
    ''' <remarks>Diese Prozedur stütz sich auf die Beispiele
    ''' "Rebuild Model Example (VB)" und
    ''' "Redraw Graphics Example (VB)" 
    ''' der SolidWorks API Hilfe</remarks>
    Public Sub ModelUpdate( _
            ByVal oSwModel As SldWorks.ModelDoc2, _
            ByVal bEditOnly As Boolean)
        Try
            'Welche Elemente sollen neu aufgebaut werden
            If bEditOnly Then
                'Nur die Elemente neu aufbauen, 
                'welche bearbeitet wurden und 
                'somit einen Neuaufbau benötigen
                oSwModel.EditRebuild3()
            Else
                'Das komplette Dokument neu aufbauen
                oSwModel.ForceRebuild3(False)
            End If
            'Darstellung im Dokumentfenster aktualisieren
            oSwModel.GraphicsRedraw2()
        Catch ex As Exception
            Debug.Assert(False)
            Trace.WriteLine("Fehler: Wo: " & _
                ex.StackTrace & " Was: " & ex.Message)
        End Try
    End Sub


End Class
